// Sobrecarga de Operadores
// + - * / = == != < > =< => & | && || % ! ~ ++ -- += -=
// *= /= ? ^ ^= |= &= :: : () [] 
// "IST" + "2014" -> "IST2014"

// TEMPLATES
// ---------
#include <iostream>
using namespace std;
template <typename Type>  
class vetor {
private:
    int tam;
    Type * vet;
public:
    vetor(int tam) : tam(tam) {
        vet = new Type[tam]; 
    }     
    Type& operator[]( int i ) {
        if( i >= 0 && i < tam )
            return vet[i];
    } 
    
    bool operator==( vetor<Type> v ) {
        if( v.tamanho() != tamanho() )
            return false;
            
        for(int i = 0; i < tamanho(); i++ )
            if( v.vet[i] != vet[i] )
                return false;
        
        return true;
    }
   
   
    int tamanho() {
        return tam;
    }
};
int main() {
    vetor < int >  v1(10);
    vetor < int >  v2(10);
    
    if( v1 == v2 ) {
        cout << "Iguais" << endl;
    } else {
        cout << "Diferentes" << endl;
    }
}


 
